/* Ce fichier compare 2 fichiers binaires, en disant de combien de caracteres ils different 
 * La commande normale consiste a appeler la commande shell
 *  	diff-binfiles f1 f2 
 *
 */

#include <stdio.h>


void usage(int argc, char** argv) {
  fprintf(stderr, "%s: Usage: %s f1 f2\n"
                  "   Entree: f1; f2: fichiers \n"
                  "   Sortie: la taille des fichiers f1 et f2 et le nombre d'octets differents\n"
		  , argv[0], argv[0]);
  fflush(stderr) ;
  exit(1) ;
}

int main(int argc, char** argv)
{

  FILE* f1 ;
  FILE* f2 ;
  int nbdiffs = 0 ;
  int size1 = 0 ;
  int size2 = 0 ;
  int c1 ; 
  int c2 ; 

  if (argc !=3) usage( argc, argv) ;
  if ( (f1 = fopen(argv[1],"r") ) == NULL) usage( argc, argv) ;
  if ( (f2 = fopen(argv[2],"r") ) == NULL) usage( argc, argv) ;

  c1 = fgetc(f1 ) ;  
  c2 = fgetc(f2 ) ;
  while ( (c1 != EOF ) || (c2 != EOF) ) {
    if (c1 != EOF ) { c1 = fgetc(f1 ) ;  size1++ ; }
    if (c2 != EOF ) { c2 = fgetc(f2 ) ;  size2++ ; }
    if  (c1 != c2) nbdiffs++ ;
  }

  if (nbdiffs != 0) {
     fprintf(stdout, "*** number of bytes in %s : %d \n", argv[1], size1 ) ; 
     fprintf(stdout, "*** number of bytes in %s : %d \n", argv[2], size2 ) ; 
     fprintf(stdout, "*** number of different bytes : %d \n", nbdiffs ) ;
  }

    return 0 ;
}


